//+------------------------------------------------------------------+
//|                                            Fibo_D_W_M_Y_v1.1.mq4 |
//|                                          Copyright 2017 WaltSoft |
//|                                   http://www.HarmonicsTrader.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017 WaltSoft"
#property link      "http://www.HarmonicsTrader.com"
//|#property icon "\\images\\HT.ico"
#property strict
#property indicator_chart_window
input int                  DWidthlines      =   0; 
input ENUM_LINE_STYLE  DFiboStyle                =  STYLE_SOLID;       //  level style?
extern bool   D_Indicator_On  = true;
extern color  D_UpperFiboColor = RoyalBlue;
extern bool   D_UpperFiboOn    = true;
extern color  D_MainFiboColor  = DarkOliveGreen;
extern bool   D_MainFiboOn     = true;
extern color  D_LowerFiboColor = IndianRed;
extern bool   D_LowerFiboOn    = true;
extern string _1_________________________ = "+++++++++++++++++++++++++++++++++++++++++";
input int                  WWidthlines      =   0; 
input ENUM_LINE_STYLE  WFiboStyle                =  STYLE_SOLID;       //  level style?
extern bool   W_Indicator_On  = true;
extern color  W_UpperFiboColor = DeepSkyBlue;
extern bool   W_UpperFiboOn    = true;
extern color  W_MainFiboColor  = MediumSpringGreen;
extern bool   W_MainFiboOn     = true;
extern color  W_LowerFiboColor = OrangeRed;
extern bool   W_LowerFiboOn    = true;
extern string _2_________________________ = "+++++++++++++++++++++++++++++++++++++++++";
input int                  MWidthlines      =   0; 
input ENUM_LINE_STYLE  MFiboStyle                =  STYLE_SOLID;       //  level style?
extern bool   M_Indicator_On  = true;
extern color  M_UpperFiboColor = LightBlue;
extern bool   M_UpperFiboOn    = true;
extern color  M_MainFiboColor  = LawnGreen;
extern bool   M_MainFiboOn     = true;
extern color  M_LowerFiboColor = Orange;
extern bool   M_LowerFiboOn    = true;
extern string _3_________________________ = "+++++++++++++++++++++++++++++++++++++++++";
input int                  YWidthlines      =   0; 
input ENUM_LINE_STYLE  YFiboStyle                =  STYLE_SOLID;       //  level style?
extern bool   Y_Indicator_On  = true;
extern color  Y_UpperFiboColor = Lavender;
extern bool   Y_UpperFiboOn    = true;
extern color  Y_MainFiboColor  = LightGreen;
extern bool   Y_MainFiboOn     = true;
extern color  Y_LowerFiboColor = Gold;
extern bool   Y_LowerFiboOn    = true;

double D_HiPrice, D_LoPrice, D_Range;
datetime D_StartTime;

double W_HiPrice, W_LoPrice, W_Range;
datetime W_StartTime;

double M_HiPrice, M_LoPrice, M_Range;
datetime M_StartTime;

double Y_HiPrice, Y_LoPrice, Y_Range;
datetime Y_StartTime;
int D_shift, W_shift, M_shift, Y_shift;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Indicator De-initializtion                                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete("D_FiboUp");
   ObjectDelete("D_FiboDn");
   ObjectDelete("D_FiboIn");
   
   ObjectDelete("W_FiboUp");
   ObjectDelete("W_FiboDn");
   ObjectDelete("W_FiboIn");
   
   ObjectDelete("M_FiboUp");
   ObjectDelete("M_FiboDn");
   ObjectDelete("M_FiboIn");
   
   ObjectDelete("Y_FiboUp");
   ObjectDelete("Y_FiboDn");
   ObjectDelete("Y_FiboIn");
   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   Comment("");
//------- D
   if (D_Indicator_On == true){
   	D_shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// yesterday
   	D_HiPrice		= iHigh(NULL,PERIOD_D1,D_shift);
   	D_LoPrice		= iLow (NULL,PERIOD_D1,D_shift);
   	D_StartTime	= iTime(NULL,PERIOD_D1,D_shift);
   
   	if(TimeDayOfWeek(D_StartTime)==0/*Sunday*/)
   	{//Add fridays high and low
   		D_HiPrice = MathMax(D_HiPrice,iHigh(NULL,PERIOD_D1,D_shift+1));
   		D_LoPrice = MathMin(D_LoPrice,iLow(NULL,PERIOD_D1,D_shift+1));
   	}
   
   	D_Range = D_HiPrice-D_LoPrice;
   	DrawFibo_D();
	}
//------ W
   if (W_Indicator_On == true){
   	W_shift	= iBarShift(NULL,PERIOD_W1,Time[0]) + 1;	// previous week
   	W_HiPrice		= iHigh(NULL,PERIOD_W1,W_shift);
   	W_LoPrice		= iLow (NULL,PERIOD_W1,W_shift);
   	W_StartTime	= iTime(NULL,PERIOD_W1,W_shift);
   
   	W_Range = W_HiPrice-W_LoPrice;
   	DrawFibo_W();
	}
//------ M
   if (M_Indicator_On == true){
   	M_shift	= iBarShift(NULL,PERIOD_MN1,Time[0]) + 1;	// previous month
   	M_HiPrice		= iHigh(NULL,PERIOD_MN1,M_shift);
   	M_LoPrice		= iLow (NULL,PERIOD_MN1,M_shift);
   	M_StartTime	= iTime(NULL,PERIOD_MN1,M_shift);
   
   	M_Range = M_HiPrice-M_LoPrice;
   	DrawFibo_M();
	}
//------ Y
   if (Y_Indicator_On == true){
      Y_shift	= iBarShift(NULL,PERIOD_MN1,Time[0]) + Month() + 11;	// January previous year
      Y_StartTime	= iTime(NULL,PERIOD_MN1,Y_shift);
      
   	Y_HiPrice		= iHigh(NULL, PERIOD_MN1, iHighest(NULL, PERIOD_MN1, MODE_HIGH, 12, Month()));
   	Y_LoPrice		= iLow(NULL, PERIOD_MN1, iLowest(NULL, PERIOD_MN1, MODE_LOW, 12, Month()));
   	Y_Range = Y_HiPrice-Y_LoPrice;
   	DrawFibo_Y();
	}
//-----------

   Comment("\nPrevious Day: ",NormalizeDouble(D_Range/Point/10,1)," Pips"
         ,"\nPrevious Week: ",NormalizeDouble(W_Range/Point/10,1)," Pips"
         ,"\nPrevious Month: ",NormalizeDouble(M_Range/Point/10,1)," Pips"
         ,"\nPrevious Year: ",NormalizeDouble(Y_Range/Point/10,1)," Pips"
   );

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Day Indicator Draw Fibo Sub-routine                              |
//+------------------------------------------------------------------+

void DrawFibo_D()
{
   if(D_UpperFiboOn)
   {
	if(ObjectFind("D_FiboUp") == -1)
	 //ObjectCreate("D_FiboUp",OBJ_FIBO,0,D_StartTime,D_HiPrice+D_Range,D_StartTime,D_HiPrice);
		ObjectCreate("D_FiboUp",OBJ_FIBO,0,D_StartTime,D_HiPrice+D_Range,D_StartTime,D_HiPrice+D_Range*0.236);
	else
	{
		ObjectSet("D_FiboUp",OBJPROP_TIME2, D_StartTime);
		ObjectSet("D_FiboUp",OBJPROP_TIME1, D_StartTime);
		ObjectSet("D_FiboUp",OBJPROP_PRICE1,D_HiPrice+D_Range);
	 //ObjectSet("D_FiboUp",OBJPROP_PRICE2,D_HiPrice);
		ObjectSet("D_FiboUp",OBJPROP_PRICE2,D_HiPrice+D_Range*0.236);
	}
   ObjectSet("D_FiboUp",OBJPROP_LEVELCOLOR,D_UpperFiboColor);
   ObjectSet("D_FiboUp",OBJPROP_LEVELWIDTH,DWidthlines);
   ObjectSet("D_FiboUp",OBJPROP_LEVELSTYLE,DFiboStyle);
   ObjectSet("D_FiboUp",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("D_FiboUp",0,"(123.6%) -  %$");
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("D_FiboUp",1,"(138.2%) -  %$");
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("D_FiboUp",2,"(150.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("D_FiboUp",3,"(161.8%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("D_FiboUp",4,"(176.4%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("D_FiboUp",5,"(200.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("D_FiboUp",6,"(223.6%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("D_FiboUp",7,"(238.2%) -  %$");
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("D_FiboUp",8,"(250.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("D_FiboUp",9,"(261.8%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("D_FiboUp",10,"(276.4%) -  %$");
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("D_FiboUp",11,"(300.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("D_FiboUp",12,"(350.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("D_FiboUp",13,"(400.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("D_FiboUp",14,"(450.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("D_FiboUp",15,"(500.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("D_FiboUp",16,"(550.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("D_FiboUp",17,"(600.0%) -  %$"); 
   ObjectSet("D_FiboUp",OBJPROP_RAY,true);
   ObjectSet("D_FiboUp",OBJPROP_BACK,true);
   }

   //-----------------------------------------------------------------
	if(D_MainFiboOn)
	{
	if(ObjectFind("D_FiboIn") == -1)
	 //ObjectCreate("D_FiboIn",OBJ_FIBO,0,D_StartTime,D_HiPrice,D_StartTime+PERIOD_D1*60,D_LoPrice); //diagonal line
		ObjectCreate("D_FiboIn",OBJ_FIBO,0,D_StartTime,D_HiPrice,D_StartTime,D_LoPrice);              //vertical line
	else
	{
		ObjectSet("D_FiboIn",OBJPROP_TIME2, D_StartTime);
	 //ObjectSet("D_FiboIn",OBJPROP_TIME1, D_StartTime+PERIOD_D1*60); //creates diagonal line
		ObjectSet("D_FiboIn",OBJPROP_TIME1, D_StartTime);              //creates vertical line
		ObjectSet("D_FiboIn",OBJPROP_PRICE1,D_HiPrice);
		ObjectSet("D_FiboIn",OBJPROP_PRICE2,D_LoPrice);
	}
   ObjectSet("D_FiboIn",OBJPROP_LEVELCOLOR,D_MainFiboColor);
   ObjectSet("D_FiboIn",OBJPROP_LEVELWIDTH,DWidthlines);
   ObjectSet("D_FiboIn",OBJPROP_LEVELSTYLE,DFiboStyle); 
   ObjectSet("D_FiboIn",OBJPROP_FIBOLEVELS,7);
   ObjectSet("D_FiboIn",OBJPROP_FIRSTLEVEL+0,0.000);	ObjectSetFiboDescription("D_FiboIn",0,"Yesterday LOW  (  0  ) -  %$"); 
   ObjectSet("D_FiboIn",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("D_FiboIn",1,"(23.6) -  %$"); 
   ObjectSet("D_FiboIn",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("D_FiboIn",2,"(38.2) -  %$"); 
   ObjectSet("D_FiboIn",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("D_FiboIn",3,"(50.0) -  %$"); 
   ObjectSet("D_FiboIn",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("D_FiboIn",4,"(61.8) -  %$"); 
   ObjectSet("D_FiboIn",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("D_FiboIn",5,"(76.4) -  %$"); 
   ObjectSet("D_FiboIn",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("D_FiboIn",6,"Yesterday HIGH  (100) -  %$"); 
   ObjectSet("D_FiboIn",OBJPROP_RAY,true);
   ObjectSet("D_FiboIn",OBJPROP_BACK,true);
   }


   //-----------------------------------------------------------------
   if(D_LowerFiboOn)
   {
	if(ObjectFind("D_FiboDn") == -1)
	 //ObjectCreate("D_FiboDn",OBJ_FIBO,0,D_StartTime,D_LoPrice-D_Range,D_StartTime,D_LoPrice);
		ObjectCreate("D_FiboDn",OBJ_FIBO,0,D_StartTime,D_LoPrice-D_Range,D_StartTime,D_LoPrice-D_Range*0.236);
	else
	{
		ObjectSet("D_FiboDn",OBJPROP_TIME2, D_StartTime);
		ObjectSet("D_FiboDn",OBJPROP_TIME1, D_StartTime);
		ObjectSet("D_FiboDn",OBJPROP_PRICE1,D_LoPrice-D_Range);
	 //ObjectSet("D_FiboDn",OBJPROP_PRICE1,D_LoPrice);
		ObjectSet("D_FiboDn",OBJPROP_PRICE2,D_LoPrice-D_Range*0.236);
	}
   ObjectSet("D_FiboDn",OBJPROP_LEVELCOLOR,D_LowerFiboColor); 
   ObjectSet("D_FiboDn",OBJPROP_LEVELWIDTH,DWidthlines);
   ObjectSet("D_FiboDn",OBJPROP_LEVELSTYLE,DFiboStyle);
   ObjectSet("D_FiboDn",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("D_FiboDn", 0,"(-23.6%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("D_FiboDn", 1,"(-38.2%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("D_FiboDn", 2,"(-50.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("D_FiboDn", 3,"(-61.8%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("D_FiboDn", 4,"(-76.4%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("D_FiboDn", 5,"(-100.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("D_FiboDn", 6,"(-123.6%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("D_FiboDn", 7,"(-138.2%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("D_FiboDn", 8,"(-150.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("D_FiboDn", 9,"(-161.8%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("D_FiboDn",10,"(-176.4%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("D_FiboDn",11,"(-200.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("D_FiboDn",12,"(-250.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("D_FiboDn",13,"(-300.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("D_FiboDn",14,"(-350.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("D_FiboDn",15,"(-400.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("D_FiboDn",16,"(-450.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("D_FiboDn",17,"(-500.0%) -  %$"); 
   ObjectSet("D_FiboDn",OBJPROP_RAY,true);
   ObjectSet("D_FiboDn",OBJPROP_BACK,true);
   } 
}

//+------------------------------------------------------------------+
//| Week Indicator Draw Fibo Sub-routine                             |
//+------------------------------------------------------------------+

void DrawFibo_W()
{
   if(W_UpperFiboOn)
   {
	if(ObjectFind("W_FiboUp") == -1)
	 //ObjectCreate("W_FiboUp",OBJ_FIBO,0,W_StartTime,W_HiPrice+W_Range,W_StartTime,W_HiPrice);
		ObjectCreate("W_FiboUp",OBJ_FIBO,0,W_StartTime,W_HiPrice+W_Range,W_StartTime,W_HiPrice+W_Range*0.236);
	else
	{
		ObjectSet("W_FiboUp",OBJPROP_TIME2, W_StartTime);
		ObjectSet("W_FiboUp",OBJPROP_TIME1, W_StartTime);
		ObjectSet("W_FiboUp",OBJPROP_PRICE1,W_HiPrice+W_Range);
	 //ObjectSet("W_FiboUp",OBJPROP_PRICE2,W_HiPrice);
		ObjectSet("W_FiboUp",OBJPROP_PRICE2,W_HiPrice+W_Range*0.236);
	}
   ObjectSet("W_FiboUp",OBJPROP_LEVELCOLOR,W_UpperFiboColor);
   ObjectSet("W_FiboUp",OBJPROP_LEVELWIDTH,WWidthlines);
   ObjectSet("W_FiboUp",OBJPROP_LEVELSTYLE,WFiboStyle);
   ObjectSet("W_FiboUp",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("W_FiboUp",0,"(123.6%) -  %$");
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("W_FiboUp",1,"(138.2%) -  %$");
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("W_FiboUp",2,"(150.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("W_FiboUp",3,"(161.8%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("W_FiboUp",4,"(176.4%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("W_FiboUp",5,"(200.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("W_FiboUp",6,"(223.6%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("W_FiboUp",7,"(238.2%) -  %$");
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("W_FiboUp",8,"(250.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("W_FiboUp",9,"(261.8%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("W_FiboUp",10,"(276.4%) -  %$");
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("W_FiboUp",11,"(300.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("W_FiboUp",12,"(350.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("W_FiboUp",13,"(400.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("W_FiboUp",14,"(450.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("W_FiboUp",15,"(500.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("W_FiboUp",16,"(550.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("W_FiboUp",17,"(600.0%) -  %$"); 
   ObjectSet("W_FiboUp",OBJPROP_RAY,true);
   ObjectSet("W_FiboUp",OBJPROP_BACK,true);
   }

   //-----------------------------------------------------------------
	if(W_MainFiboOn)
	{
	if(ObjectFind("W_FiboIn") == -1)
	 //ObjectCreate("W_FiboIn",OBJ_FIBO,0,W_StartTime,W_HiPrice,W_StartTime+PERIOW_W1*60,W_LoPrice); //diagonal line
		ObjectCreate("W_FiboIn",OBJ_FIBO,0,W_StartTime,W_HiPrice,W_StartTime,W_LoPrice);              //vertical line
	else
	{
		ObjectSet("W_FiboIn",OBJPROP_TIME2, W_StartTime);
	 //ObjectSet("W_FiboIn",OBJPROP_TIME1, W_StartTime+PERIOW_W1*60); //creates diagonal line
		ObjectSet("W_FiboIn",OBJPROP_TIME1, W_StartTime);              //creates vertical line
		ObjectSet("W_FiboIn",OBJPROP_PRICE1,W_HiPrice);
		ObjectSet("W_FiboIn",OBJPROP_PRICE2,W_LoPrice);
	}
   ObjectSet("W_FiboIn",OBJPROP_LEVELCOLOR,W_MainFiboColor);
   ObjectSet("W_FiboIn",OBJPROP_LEVELWIDTH,WWidthlines);
   ObjectSet("W_FiboIn",OBJPROP_LEVELSTYLE,WFiboStyle); 
   ObjectSet("W_FiboIn",OBJPROP_FIBOLEVELS,7);
   ObjectSet("W_FiboIn",OBJPROP_FIRSTLEVEL+0,0.000);	ObjectSetFiboDescription("W_FiboIn",0,"Previous Week LOW  (  0  ) -  %$"); 
   ObjectSet("W_FiboIn",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("W_FiboIn",1,"(23.6) -  %$"); 
   ObjectSet("W_FiboIn",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("W_FiboIn",2,"(38.2) -  %$"); 
   ObjectSet("W_FiboIn",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("W_FiboIn",3,"(50.0) -  %$"); 
   ObjectSet("W_FiboIn",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("W_FiboIn",4,"(61.8) -  %$"); 
   ObjectSet("W_FiboIn",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("W_FiboIn",5,"(76.4) -  %$"); 
   ObjectSet("W_FiboIn",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("W_FiboIn",6,"Previous Week HIGH  (100) -  %$"); 
   ObjectSet("W_FiboIn",OBJPROP_RAY,true);
   ObjectSet("W_FiboIn",OBJPROP_BACK,true);
   }


   //-----------------------------------------------------------------
   if(W_LowerFiboOn)
   {
	if(ObjectFind("W_FiboDn") == -1)
	 //ObjectCreate("W_FiboDn",OBJ_FIBO,0,W_StartTime,W_LoPrice-W_Range,W_StartTime,W_LoPrice);
		ObjectCreate("W_FiboDn",OBJ_FIBO,0,W_StartTime,W_LoPrice-W_Range,W_StartTime,W_LoPrice-W_Range*0.236);
	else
	{
		ObjectSet("W_FiboDn",OBJPROP_TIME2, W_StartTime);
		ObjectSet("W_FiboDn",OBJPROP_TIME1, W_StartTime);
		ObjectSet("W_FiboDn",OBJPROP_PRICE1,W_LoPrice-W_Range);
	 //ObjectSet("W_FiboDn",OBJPROP_PRICE1,W_LoPrice);
		ObjectSet("W_FiboDn",OBJPROP_PRICE2,W_LoPrice-W_Range*0.236);
	}
   ObjectSet("W_FiboDn",OBJPROP_LEVELCOLOR,W_LowerFiboColor);
   ObjectSet("W_FiboDn",OBJPROP_LEVELWIDTH,WWidthlines);
   ObjectSet("W_FiboDn",OBJPROP_LEVELSTYLE,WFiboStyle); 
   ObjectSet("W_FiboDn",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("W_FiboDn", 0,"(-23.6%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("W_FiboDn", 1,"(-38.2%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("W_FiboDn", 2,"(-50.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("W_FiboDn", 3,"(-61.8%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("W_FiboDn", 4,"(-76.4%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("W_FiboDn", 5,"(-100.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("W_FiboDn", 6,"(-123.6%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("W_FiboDn", 7,"(-138.2%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("W_FiboDn", 8,"(-150.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("W_FiboDn", 9,"(-161.8%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("W_FiboDn",10,"(-176.4%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("W_FiboDn",11,"(-200.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("W_FiboDn",12,"(-250.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("W_FiboDn",13,"(-300.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("W_FiboDn",14,"(-350.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("W_FiboDn",15,"(-400.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("W_FiboDn",16,"(-450.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("W_FiboDn",17,"(-500.0%) -  %$"); 
   ObjectSet("W_FiboDn",OBJPROP_RAY,true);
   ObjectSet("W_FiboDn",OBJPROP_BACK,true);
   } 
}

//+------------------------------------------------------------------+
//| Month Indicator Draw Fibo Sub-routine                            |
//+------------------------------------------------------------------+

void DrawFibo_M()
{
   if(M_UpperFiboOn)
   {
	if(ObjectFind("M_FiboUp") == -1)
	 //ObjectCreate("M_FiboUp",OBJ_FIBO,0,M_StartTime,M_HiPrice+M_Range,M_StartTime,M_HiPrice);
		ObjectCreate("M_FiboUp",OBJ_FIBO,0,M_StartTime,M_HiPrice+M_Range,M_StartTime,M_HiPrice+M_Range*0.236);
	else
	{
		ObjectSet("M_FiboUp",OBJPROP_TIME2, M_StartTime);
		ObjectSet("M_FiboUp",OBJPROP_TIME1, M_StartTime);
		ObjectSet("M_FiboUp",OBJPROP_PRICE1,M_HiPrice+M_Range);
	 //ObjectSet("M_FiboUp",OBJPROP_PRICE2,M_HiPrice);
		ObjectSet("M_FiboUp",OBJPROP_PRICE2,M_HiPrice+M_Range*0.236);
	}
   ObjectSet("M_FiboUp",OBJPROP_LEVELCOLOR,M_UpperFiboColor);
   ObjectSet("M_FiboUp",OBJPROP_LEVELWIDTH,MWidthlines);
   ObjectSet("M_FiboUp",OBJPROP_LEVELSTYLE,MFiboStyle);
   ObjectSet("M_FiboUp",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("M_FiboUp",0,"(123.6%) -  %$");
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("M_FiboUp",1,"(138.2%) -  %$");
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("M_FiboUp",2,"(150.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("M_FiboUp",3,"(161.8%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("M_FiboUp",4,"(176.4%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("M_FiboUp",5,"(200.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("M_FiboUp",6,"(223.6%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("M_FiboUp",7,"(238.2%) -  %$");
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("M_FiboUp",8,"(250.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("M_FiboUp",9,"(261.8%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("M_FiboUp",10,"(276.4%) -  %$");
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("M_FiboUp",11,"(300.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("M_FiboUp",12,"(350.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("M_FiboUp",13,"(400.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("M_FiboUp",14,"(450.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("M_FiboUp",15,"(500.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("M_FiboUp",16,"(550.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("M_FiboUp",17,"(600.0%) -  %$"); 
   ObjectSet("M_FiboUp",OBJPROP_RAY,true);
   ObjectSet("M_FiboUp",OBJPROP_BACK,true);
   }

   //-----------------------------------------------------------------
	if(M_MainFiboOn)
	{
	if(ObjectFind("M_FiboIn") == -1)
	 //ObjectCreate("M_FiboIn",OBJ_FIBO,0,M_StartTime,M_HiPrice,M_StartTime+PERIOM_W1*60,M_LoPrice); //diagonal line
		ObjectCreate("M_FiboIn",OBJ_FIBO,0,M_StartTime,M_HiPrice,M_StartTime,M_LoPrice);              //vertical line
	else
	{
		ObjectSet("M_FiboIn",OBJPROP_TIME2, M_StartTime);
	 //ObjectSet("M_FiboIn",OBJPROP_TIME1, M_StartTime+PERIOM_W1*60); //creates diagonal line
		ObjectSet("M_FiboIn",OBJPROP_TIME1, M_StartTime);              //creates vertical line
		ObjectSet("M_FiboIn",OBJPROP_PRICE1,M_HiPrice);
		ObjectSet("M_FiboIn",OBJPROP_PRICE2,M_LoPrice);
	}
   ObjectSet("M_FiboIn",OBJPROP_LEVELCOLOR,M_MainFiboColor);
   ObjectSet("M_FiboIn",OBJPROP_LEVELWIDTH,MWidthlines);
   ObjectSet("M_FiboIn",OBJPROP_LEVELSTYLE,MFiboStyle); 
   ObjectSet("M_FiboIn",OBJPROP_FIBOLEVELS,7);
   ObjectSet("M_FiboIn",OBJPROP_FIRSTLEVEL+0,0.000);	ObjectSetFiboDescription("M_FiboIn",0,"Previous Month LOW  (  0  ) -  %$"); 
   ObjectSet("M_FiboIn",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("M_FiboIn",1,"(23.6) -  %$"); 
   ObjectSet("M_FiboIn",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("M_FiboIn",2,"(38.2) -  %$"); 
   ObjectSet("M_FiboIn",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("M_FiboIn",3,"(50.0) -  %$"); 
   ObjectSet("M_FiboIn",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("M_FiboIn",4,"(61.8) -  %$"); 
   ObjectSet("M_FiboIn",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("M_FiboIn",5,"(76.4) -  %$"); 
   ObjectSet("M_FiboIn",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("M_FiboIn",6,"Previous Month HIGH  (100) -  %$"); 
   ObjectSet("M_FiboIn",OBJPROP_RAY,true);
   ObjectSet("M_FiboIn",OBJPROP_BACK,true);
   }


   //-----------------------------------------------------------------
   if(M_LowerFiboOn)
   {
	if(ObjectFind("M_FiboDn") == -1)
	 //ObjectCreate("M_FiboDn",OBJ_FIBO,0,M_StartTime,M_LoPrice-M_Range,M_StartTime,M_LoPrice);
		ObjectCreate("M_FiboDn",OBJ_FIBO,0,M_StartTime,M_LoPrice-M_Range,M_StartTime,M_LoPrice-M_Range*0.236);
	else
	{
		ObjectSet("M_FiboDn",OBJPROP_TIME2, M_StartTime);
		ObjectSet("M_FiboDn",OBJPROP_TIME1, M_StartTime);
		ObjectSet("M_FiboDn",OBJPROP_PRICE1,M_LoPrice-M_Range);
	 //ObjectSet("M_FiboDn",OBJPROP_PRICE1,M_LoPrice);
		ObjectSet("M_FiboDn",OBJPROP_PRICE2,M_LoPrice-M_Range*0.236);
	}
   ObjectSet("M_FiboDn",OBJPROP_LEVELCOLOR,M_LowerFiboColor);
   ObjectSet("M_FiboDn",OBJPROP_LEVELWIDTH,MWidthlines);
   ObjectSet("M_FiboDn",OBJPROP_LEVELSTYLE,MFiboStyle); 
   ObjectSet("M_FiboDn",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("M_FiboDn", 0,"(-23.6%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("M_FiboDn", 1,"(-38.2%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("M_FiboDn", 2,"(-50.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("M_FiboDn", 3,"(-61.8%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("M_FiboDn", 4,"(-76.4%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("M_FiboDn", 5,"(-100.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("M_FiboDn", 6,"(-123.6%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("M_FiboDn", 7,"(-138.2%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("M_FiboDn", 8,"(-150.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("M_FiboDn", 9,"(-161.8%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("M_FiboDn",10,"(-176.4%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("M_FiboDn",11,"(-200.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("M_FiboDn",12,"(-250.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("M_FiboDn",13,"(-300.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("M_FiboDn",14,"(-350.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("M_FiboDn",15,"(-400.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("M_FiboDn",16,"(-450.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("M_FiboDn",17,"(-500.0%) -  %$"); 
   ObjectSet("M_FiboDn",OBJPROP_RAY,true);
   ObjectSet("M_FiboDn",OBJPROP_BACK,true);
   } 
}

//+------------------------------------------------------------------+
//| Year Indicator Draw Fibo Sub-routine                            |
//+------------------------------------------------------------------+

void DrawFibo_Y()
{
   if(Y_UpperFiboOn)
   {
	if(ObjectFind("Y_FiboUp") == -1)
	 //ObjectCreate("Y_FiboUp",OBJ_FIBO,0,Y_StartTime,Y_HiPrice+Y_Range,Y_StartTime,Y_HiPrice);
		ObjectCreate("Y_FiboUp",OBJ_FIBO,0,Y_StartTime,Y_HiPrice+Y_Range,Y_StartTime,Y_HiPrice+Y_Range*0.236);
	else
	{
		ObjectSet("Y_FiboUp",OBJPROP_TIME2, Y_StartTime);
		ObjectSet("Y_FiboUp",OBJPROP_TIME1, Y_StartTime);
		ObjectSet("Y_FiboUp",OBJPROP_PRICE1,Y_HiPrice+Y_Range);
	 //ObjectSet("Y_FiboUp",OBJPROP_PRICE2,Y_HiPrice);
		ObjectSet("Y_FiboUp",OBJPROP_PRICE2,Y_HiPrice+Y_Range*0.236);
	}
   ObjectSet("Y_FiboUp",OBJPROP_LEVELCOLOR,Y_UpperFiboColor);
   ObjectSet("Y_FiboUp",OBJPROP_LEVELWIDTH,YWidthlines);
   ObjectSet("Y_FiboUp",OBJPROP_LEVELSTYLE,YFiboStyle);
   ObjectSet("Y_FiboUp",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("Y_FiboUp",0,"(123.6%) -  %$");
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("Y_FiboUp",1,"(138.2%) -  %$");
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("Y_FiboUp",2,"(150.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("Y_FiboUp",3,"(161.8%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("Y_FiboUp",4,"(176.4%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("Y_FiboUp",5,"(200.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("Y_FiboUp",6,"(223.6%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("Y_FiboUp",7,"(238.2%) -  %$");
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("Y_FiboUp",8,"(250.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("Y_FiboUp",9,"(261.8%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("Y_FiboUp",10,"(276.4%) -  %$");
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("Y_FiboUp",11,"(300.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("Y_FiboUp",12,"(350.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("Y_FiboUp",13,"(400.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("Y_FiboUp",14,"(450.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("Y_FiboUp",15,"(500.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("Y_FiboUp",16,"(550.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("Y_FiboUp",17,"(600.0%) -  %$"); 
   ObjectSet("Y_FiboUp",OBJPROP_RAY,true);
   ObjectSet("Y_FiboUp",OBJPROP_BACK,true);
   }

   //-----------------------------------------------------------------
	if(Y_MainFiboOn)
	{
	if(ObjectFind("Y_FiboIn") == -1)
	 //ObjectCreate("Y_FiboIn",OBJ_FIBO,0,Y_StartTime,Y_HiPrice,Y_StartTime+PERIOY_W1*60,Y_LoPrice); //diagonal line
		ObjectCreate("Y_FiboIn",OBJ_FIBO,0,Y_StartTime,Y_HiPrice,Y_StartTime,Y_LoPrice);              //vertical line
	else
	{
		ObjectSet("Y_FiboIn",OBJPROP_TIME2, Y_StartTime);
	 //ObjectSet("Y_FiboIn",OBJPROP_TIME1, Y_StartTime+PERIOY_W1*60); //creates diagonal line
		ObjectSet("Y_FiboIn",OBJPROP_TIME1, Y_StartTime);              //creates vertical line
		ObjectSet("Y_FiboIn",OBJPROP_PRICE1,Y_HiPrice);
		ObjectSet("Y_FiboIn",OBJPROP_PRICE2,Y_LoPrice);
	}
   ObjectSet("Y_FiboIn",OBJPROP_LEVELCOLOR,Y_MainFiboColor); 
   ObjectSet("Y_FiboIn",OBJPROP_LEVELWIDTH,YWidthlines);
   ObjectSet("Y_FiboIn",OBJPROP_LEVELSTYLE,YFiboStyle);
   ObjectSet("Y_FiboIn",OBJPROP_FIBOLEVELS,7);
   ObjectSet("Y_FiboIn",OBJPROP_FIRSTLEVEL+0,0.000);	ObjectSetFiboDescription("Y_FiboIn",0,"Previous Year LOW  (  0  ) -  %$"); 
   ObjectSet("Y_FiboIn",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("Y_FiboIn",1,"(23.6) -  %$"); 
   ObjectSet("Y_FiboIn",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("Y_FiboIn",2,"(38.2) -  %$"); 
   ObjectSet("Y_FiboIn",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("Y_FiboIn",3,"(50.0) -  %$"); 
   ObjectSet("Y_FiboIn",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("Y_FiboIn",4,"(61.8) -  %$"); 
   ObjectSet("Y_FiboIn",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("Y_FiboIn",5,"(76.4) -  %$"); 
   ObjectSet("Y_FiboIn",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("Y_FiboIn",6,"Previous Year HIGH  (100) -  %$"); 
   ObjectSet("Y_FiboIn",OBJPROP_RAY,true);
   ObjectSet("Y_FiboIn",OBJPROP_BACK,true);
   }


   //-----------------------------------------------------------------
   if(Y_LowerFiboOn)
   {
	if(ObjectFind("Y_FiboDn") == -1)
	 //ObjectCreate("Y_FiboDn",OBJ_FIBO,0,Y_StartTime,Y_LoPrice-Y_Range,Y_StartTime,Y_LoPrice);
		ObjectCreate("Y_FiboDn",OBJ_FIBO,0,Y_StartTime,Y_LoPrice-Y_Range,Y_StartTime,Y_LoPrice-Y_Range*0.236);
	else
	{
		ObjectSet("Y_FiboDn",OBJPROP_TIME2, Y_StartTime);
		ObjectSet("Y_FiboDn",OBJPROP_TIME1, Y_StartTime);
		ObjectSet("Y_FiboDn",OBJPROP_PRICE1,Y_LoPrice-Y_Range);
	 //ObjectSet("Y_FiboDn",OBJPROP_PRICE1,Y_LoPrice);
		ObjectSet("Y_FiboDn",OBJPROP_PRICE2,Y_LoPrice-Y_Range*0.236);
	}
   ObjectSet("Y_FiboDn",OBJPROP_LEVELCOLOR,Y_LowerFiboColor); 
   ObjectSet("Y_FiboDn",OBJPROP_LEVELWIDTH,YWidthlines);
   ObjectSet("Y_FiboDn",OBJPROP_LEVELSTYLE,YFiboStyle);
   ObjectSet("Y_FiboDn",OBJPROP_FIBOLEVELS,18);   
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 0,0.000); ObjectSetFiboDescription("Y_FiboDn", 0,"(-23.6%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 1,0.189); ObjectSetFiboDescription("Y_FiboDn", 1,"(-38.2%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 2,0.346); ObjectSetFiboDescription("Y_FiboDn", 2,"(-50.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 3,0.500); ObjectSetFiboDescription("Y_FiboDn", 3,"(-61.8%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 4,0.691); ObjectSetFiboDescription("Y_FiboDn", 4,"(-76.4%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 5,1.000); ObjectSetFiboDescription("Y_FiboDn", 5,"(-100.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 6,1.311); ObjectSetFiboDescription("Y_FiboDn", 6,"(-123.6%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 7,1.500); ObjectSetFiboDescription("Y_FiboDn", 7,"(-138.2%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 8,1.654); ObjectSetFiboDescription("Y_FiboDn", 8,"(-150.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+ 9,1.810); ObjectSetFiboDescription("Y_FiboDn", 9,"(-161.8%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+10,2.000); ObjectSetFiboDescription("Y_FiboDn",10,"(-176.4%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+11,2.309); ObjectSetFiboDescription("Y_FiboDn",11,"(-200.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+12,2.960); ObjectSetFiboDescription("Y_FiboDn",12,"(-250.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+13,3.618); ObjectSetFiboDescription("Y_FiboDn",13,"(-300.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+14,4.272); ObjectSetFiboDescription("Y_FiboDn",14,"(-350.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+15,4.927); ObjectSetFiboDescription("Y_FiboDn",15,"(-400.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+16,5.578); ObjectSetFiboDescription("Y_FiboDn",16,"(-450.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_FIRSTLEVEL+17,6.236); ObjectSetFiboDescription("Y_FiboDn",17,"(-500.0%) -  %$"); 
   ObjectSet("Y_FiboDn",OBJPROP_RAY,true);
   ObjectSet("Y_FiboDn",OBJPROP_BACK,true);
   } 
}
